git-rebase.shon commit Windows: avoid the "dup dance" when spawning a child process (75301f9)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--onto <newbase>] [<upstream>|--root] [<branch>] [--quiet | -q]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .git/rebase-apply working files, use the
  18command git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.
  22
  23Example:       git-rebase master~1 topic
  24
  25        A---B---C topic                   A'\''--B'\''--C'\'' topic
  26       /                   -->           /
  27  D---E---F---G master          D---E---F---G master
  28'
  29
  30SUBDIRECTORY_OK=Yes
  31OPTIONS_SPEC=
  32. git-sh-setup
  33set_reflog_action rebase
  34require_work_tree
  35cd_to_toplevel
  36
  37LF='
  38'
  39OK_TO_SKIP_PRE_REBASE=
  40RESOLVEMSG="
  41When you have resolved this problem run \"git rebase --continue\".
  42If you would prefer to skip this patch, instead run \"git rebase --skip\".
  43To restore the original branch and stop rebasing run \"git rebase --abort\".
  44"
  45unset newbase
  46strategy=recursive
  47do_merge=
  48dotest="$GIT_DIR"/rebase-merge
  49prec=4
  50verbose=
  51diffstat=$(git config --bool rebase.stat)
  52git_am_opt=
  53rebase_root=
  54force_rebase=
  55
  56continue_merge () {
  57        test -n "$prev_head" || die "prev_head must be defined"
  58        test -d "$dotest" || die "$dotest directory does not exist"
  59
  60        unmerged=$(git ls-files -u)
  61        if test -n "$unmerged"
  62        then
  63                echo "You still have unmerged paths in your index"
  64                echo "did you forget to use git add?"
  65                die "$RESOLVEMSG"
  66        fi
  67
  68        cmt=`cat "$dotest/current"`
  69        if ! git diff-index --quiet --ignore-submodules HEAD --
  70        then
  71                if ! git commit --no-verify -C "$cmt"
  72                then
  73                        echo "Commit failed, please do not call \"git commit\""
  74                        echo "directly, but instead do one of the following: "
  75                        die "$RESOLVEMSG"
  76                fi
  77                if test -z "$GIT_QUIET"
  78                then
  79                        printf "Committed: %0${prec}d " $msgnum
  80                fi
  81        else
  82                if test -z "$GIT_QUIET"
  83                then
  84                        printf "Already applied: %0${prec}d " $msgnum
  85                fi
  86        fi
  87        if test -z "$GIT_QUIET"
  88        then
  89                git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
  90        fi
  91
  92        prev_head=`git rev-parse HEAD^0`
  93        # save the resulting commit so we can read-tree on it later
  94        echo "$prev_head" > "$dotest/prev_head"
  95
  96        # onto the next patch:
  97        msgnum=$(($msgnum + 1))
  98        echo "$msgnum" >"$dotest/msgnum"
  99}
 100
 101call_merge () {
 102        cmt="$(cat "$dotest/cmt.$1")"
 103        echo "$cmt" > "$dotest/current"
 104        hd=$(git rev-parse --verify HEAD)
 105        cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
 106        msgnum=$(cat "$dotest/msgnum")
 107        end=$(cat "$dotest/end")
 108        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
 109        eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
 110        export GITHEAD_$cmt GITHEAD_$hd
 111        if test -n "$GIT_QUIET"
 112        then
 113                export GIT_MERGE_VERBOSITY=1
 114        fi
 115        git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
 116        rv=$?
 117        case "$rv" in
 118        0)
 119                unset GITHEAD_$cmt GITHEAD_$hd
 120                return
 121                ;;
 122        1)
 123                git rerere
 124                die "$RESOLVEMSG"
 125                ;;
 126        2)
 127                echo "Strategy: $rv $strategy failed, try another" 1>&2
 128                die "$RESOLVEMSG"
 129                ;;
 130        *)
 131                die "Unknown exit code ($rv) from command:" \
 132                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 133                ;;
 134        esac
 135}
 136
 137move_to_original_branch () {
 138        test -z "$head_name" &&
 139                head_name="$(cat "$dotest"/head-name)" &&
 140                onto="$(cat "$dotest"/onto)" &&
 141                orig_head="$(cat "$dotest"/orig-head)"
 142        case "$head_name" in
 143        refs/*)
 144                message="rebase finished: $head_name onto $onto"
 145                git update-ref -m "$message" \
 146                        $head_name $(git rev-parse HEAD) $orig_head &&
 147                git symbolic-ref HEAD $head_name ||
 148                die "Could not move back to $head_name"
 149                ;;
 150        esac
 151}
 152
 153finish_rb_merge () {
 154        move_to_original_branch
 155        rm -r "$dotest"
 156        say All done.
 157}
 158
 159is_interactive () {
 160        while test $# != 0
 161        do
 162                case "$1" in
 163                        -i|--interactive)
 164                                interactive_rebase=explicit
 165                                break
 166                        ;;
 167                        -p|--preserve-merges)
 168                                interactive_rebase=implied
 169                        ;;
 170                esac
 171                shift
 172        done
 173
 174        if [ "$interactive_rebase" = implied ]; then
 175                GIT_EDITOR=:
 176                export GIT_EDITOR
 177        fi
 178
 179        test -n "$interactive_rebase" || test -f "$dotest"/interactive
 180}
 181
 182run_pre_rebase_hook () {
 183        if test -z "$OK_TO_SKIP_PRE_REBASE" &&
 184           test -x "$GIT_DIR/hooks/pre-rebase"
 185        then
 186                "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
 187                die "The pre-rebase hook refused to rebase."
 188        fi
 189}
 190
 191test -f "$GIT_DIR"/rebase-apply/applying &&
 192        die 'It looks like git-am is in progress. Cannot rebase.'
 193
 194is_interactive "$@" && exec git-rebase--interactive "$@"
 195
 196if test $# -eq 0
 197then
 198        test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
 199        test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
 200                die 'A rebase is in progress, try --continue, --skip or --abort.'
 201        die "No arguments given and $GIT_DIR/rebase-apply already exists."
 202fi
 203
 204while test $# != 0
 205do
 206        case "$1" in
 207        --no-verify)
 208                OK_TO_SKIP_PRE_REBASE=yes
 209                ;;
 210        --continue)
 211                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 212                        die "No rebase in progress?"
 213
 214                git diff-files --quiet --ignore-submodules || {
 215                        echo "You must edit all merge conflicts and then"
 216                        echo "mark them as resolved using git add"
 217                        exit 1
 218                }
 219                if test -d "$dotest"
 220                then
 221                        prev_head=$(cat "$dotest/prev_head")
 222                        end=$(cat "$dotest/end")
 223                        msgnum=$(cat "$dotest/msgnum")
 224                        onto=$(cat "$dotest/onto")
 225                        GIT_QUIET=$(cat "$dotest/quiet")
 226                        continue_merge
 227                        while test "$msgnum" -le "$end"
 228                        do
 229                                call_merge "$msgnum"
 230                                continue_merge
 231                        done
 232                        finish_rb_merge
 233                        exit
 234                fi
 235                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 236                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 237                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 238                GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
 239                git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
 240                move_to_original_branch
 241                exit
 242                ;;
 243        --skip)
 244                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 245                        die "No rebase in progress?"
 246
 247                git reset --hard HEAD || exit $?
 248                if test -d "$dotest"
 249                then
 250                        git rerere clear
 251                        prev_head=$(cat "$dotest/prev_head")
 252                        end=$(cat "$dotest/end")
 253                        msgnum=$(cat "$dotest/msgnum")
 254                        msgnum=$(($msgnum + 1))
 255                        onto=$(cat "$dotest/onto")
 256                        GIT_QUIET=$(cat "$dotest/quiet")
 257                        while test "$msgnum" -le "$end"
 258                        do
 259                                call_merge "$msgnum"
 260                                continue_merge
 261                        done
 262                        finish_rb_merge
 263                        exit
 264                fi
 265                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 266                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 267                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 268                GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
 269                git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
 270                move_to_original_branch
 271                exit
 272                ;;
 273        --abort)
 274                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 275                        die "No rebase in progress?"
 276
 277                git rerere clear
 278                if test -d "$dotest"
 279                then
 280                        GIT_QUIET=$(cat "$dotest/quiet")
 281                        move_to_original_branch
 282                else
 283                        dotest="$GIT_DIR"/rebase-apply
 284                        GIT_QUIET=$(cat "$dotest/quiet")
 285                        move_to_original_branch
 286                fi
 287                git reset --hard $(cat "$dotest/orig-head")
 288                rm -r "$dotest"
 289                exit
 290                ;;
 291        --onto)
 292                test 2 -le "$#" || usage
 293                newbase="$2"
 294                shift
 295                ;;
 296        -M|-m|--m|--me|--mer|--merg|--merge)
 297                do_merge=t
 298                ;;
 299        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 300                --strateg=*|--strategy=*|\
 301        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 302                case "$#,$1" in
 303                *,*=*)
 304                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 305                1,*)
 306                        usage ;;
 307                *)
 308                        strategy="$2"
 309                        shift ;;
 310                esac
 311                do_merge=t
 312                ;;
 313        -n|--no-stat)
 314                diffstat=
 315                ;;
 316        --stat)
 317                diffstat=t
 318                ;;
 319        -v|--verbose)
 320                verbose=t
 321                diffstat=t
 322                GIT_QUIET=
 323                ;;
 324        -q|--quiet)
 325                GIT_QUIET=t
 326                git_am_opt="$git_am_opt -q"
 327                verbose=
 328                diffstat=
 329                ;;
 330        --whitespace=*)
 331                git_am_opt="$git_am_opt $1"
 332                case "$1" in
 333                --whitespace=fix|--whitespace=strip)
 334                        force_rebase=t
 335                        ;;
 336                esac
 337                ;;
 338        --ignore-whitespace)
 339                git_am_opt="$git_am_opt $1"
 340                ;;
 341        --committer-date-is-author-date|--ignore-date)
 342                git_am_opt="$git_am_opt $1"
 343                force_rebase=t
 344                ;;
 345        -C*)
 346                git_am_opt="$git_am_opt $1"
 347                ;;
 348        --root)
 349                rebase_root=t
 350                ;;
 351        -f|--f|--fo|--for|--forc|force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase)
 352                force_rebase=t
 353                ;;
 354        -*)
 355                usage
 356                ;;
 357        *)
 358                break
 359                ;;
 360        esac
 361        shift
 362done
 363test $# -gt 2 && usage
 364
 365# Make sure we do not have $GIT_DIR/rebase-apply
 366if test -z "$do_merge"
 367then
 368        if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
 369        then
 370                rmdir "$GIT_DIR"/rebase-apply
 371        else
 372                echo >&2 '
 373It seems that I cannot create a rebase-apply directory, and
 374I wonder if you are in the middle of patch application or another
 375rebase.  If that is not the case, please
 376        rm -fr '"$GIT_DIR"'/rebase-apply
 377and run me again.  I am stopping in case you still have something
 378valuable there.'
 379                exit 1
 380        fi
 381else
 382        if test -d "$dotest"
 383        then
 384                die "previous rebase directory $dotest still exists." \
 385                        'Try git rebase (--continue | --abort | --skip)'
 386        fi
 387fi
 388
 389# The tree must be really really clean.
 390if ! git update-index --ignore-submodules --refresh > /dev/null; then
 391        echo >&2 "cannot rebase: you have unstaged changes"
 392        git diff-files --name-status -r --ignore-submodules -- >&2
 393        exit 1
 394fi
 395diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
 396case "$diff" in
 397?*)     echo >&2 "cannot rebase: your index contains uncommitted changes"
 398        echo >&2 "$diff"
 399        exit 1
 400        ;;
 401esac
 402
 403if test -z "$rebase_root"
 404then
 405        # The upstream head must be given.  Make sure it is valid.
 406        upstream_name="$1"
 407        shift
 408        upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 409        die "invalid upstream $upstream_name"
 410        unset root_flag
 411        upstream_arg="$upstream_name"
 412else
 413        test -z "$newbase" && die "--root must be used with --onto"
 414        unset upstream_name
 415        unset upstream
 416        root_flag="--root"
 417        upstream_arg="$root_flag"
 418fi
 419
 420# Make sure the branch to rebase onto is valid.
 421onto_name=${newbase-"$upstream_name"}
 422case "$onto_name" in
 423*...*)
 424        if      left=${onto_name%...*} right=${onto_name#*...} &&
 425                onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 426        then
 427                case "$onto" in
 428                ?*"$LF"?*)
 429                        die "$onto_name: there are more than one merge bases"
 430                        ;;
 431                '')
 432                        die "$onto_name: there is no merge base"
 433                        ;;
 434                esac
 435        else
 436                die "$onto_name: there is no merge base"
 437        fi
 438        ;;
 439*)
 440        onto=$(git rev-parse --verify "${onto_name}^0") || exit
 441        ;;
 442esac
 443
 444# If a hook exists, give it a chance to interrupt
 445run_pre_rebase_hook "$upstream_arg" "$@"
 446
 447# If the branch to rebase is given, that is the branch we will rebase
 448# $branch_name -- branch being rebased, or HEAD (already detached)
 449# $orig_head -- commit object name of tip of the branch before rebasing
 450# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 451switch_to=
 452case "$#" in
 4531)
 454        # Is it "rebase other $branchname" or "rebase other $commit"?
 455        branch_name="$1"
 456        switch_to="$1"
 457
 458        if git show-ref --verify --quiet -- "refs/heads/$1" &&
 459           branch=$(git rev-parse -q --verify "refs/heads/$1")
 460        then
 461                head_name="refs/heads/$1"
 462        elif branch=$(git rev-parse -q --verify "$1")
 463        then
 464                head_name="detached HEAD"
 465        else
 466                usage
 467        fi
 468        ;;
 469*)
 470        # Do not need to switch branches, we are already on it.
 471        if branch_name=`git symbolic-ref -q HEAD`
 472        then
 473                head_name=$branch_name
 474                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 475        else
 476                head_name="detached HEAD"
 477                branch_name=HEAD ;# detached
 478        fi
 479        branch=$(git rev-parse --verify "${branch_name}^0") || exit
 480        ;;
 481esac
 482orig_head=$branch
 483
 484# Now we are rebasing commits $upstream..$branch (or with --root,
 485# everything leading up to $branch) on top of $onto
 486
 487# Check if we are already based on $onto with linear history,
 488# but this should be done only when upstream and onto are the same.
 489mb=$(git merge-base "$onto" "$branch")
 490if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
 491        # linear history?
 492        ! (git rev-list --parents "$onto".."$branch" | sane_grep " .* ") > /dev/null
 493then
 494        if test -z "$force_rebase"
 495        then
 496                # Lazily switch to the target branch if needed...
 497                test -z "$switch_to" || git checkout "$switch_to"
 498                say "Current branch $branch_name is up to date."
 499                exit 0
 500        else
 501                say "Current branch $branch_name is up to date, rebase forced."
 502        fi
 503fi
 504
 505# Detach HEAD and reset the tree
 506say "First, rewinding head to replay your work on top of it..."
 507git checkout -q "$onto^0" || die "could not detach HEAD"
 508git update-ref ORIG_HEAD $branch
 509
 510if test -n "$diffstat"
 511then
 512        if test -n "$verbose"
 513        then
 514                echo "Changes from $mb to $onto:"
 515        fi
 516        # We want color (if set), but no pager
 517        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 518fi
 519
 520# If the $onto is a proper descendant of the tip of the branch, then
 521# we just fast-forwarded.
 522if test "$mb" = "$branch"
 523then
 524        say "Fast-forwarded $branch_name to $onto_name."
 525        move_to_original_branch
 526        exit 0
 527fi
 528
 529if test -n "$rebase_root"
 530then
 531        revisions="$onto..$orig_head"
 532else
 533        revisions="$upstream..$orig_head"
 534fi
 535
 536if test -z "$do_merge"
 537then
 538        git format-patch -k --stdout --full-index --ignore-if-in-upstream \
 539                $root_flag "$revisions" |
 540        git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
 541        move_to_original_branch
 542        ret=$?
 543        test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
 544                echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
 545                echo $onto > "$GIT_DIR"/rebase-apply/onto &&
 546                echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
 547                echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
 548        exit $ret
 549fi
 550
 551# start doing a rebase with git-merge
 552# this is rename-aware if the recursive (default) strategy is used
 553
 554mkdir -p "$dotest"
 555echo "$onto" > "$dotest/onto"
 556echo "$onto_name" > "$dotest/onto_name"
 557prev_head=$orig_head
 558echo "$prev_head" > "$dotest/prev_head"
 559echo "$orig_head" > "$dotest/orig-head"
 560echo "$head_name" > "$dotest/head-name"
 561echo "$GIT_QUIET" > "$dotest/quiet"
 562
 563msgnum=0
 564for cmt in `git rev-list --reverse --no-merges "$revisions"`
 565do
 566        msgnum=$(($msgnum + 1))
 567        echo "$cmt" > "$dotest/cmt.$msgnum"
 568done
 569
 570echo 1 >"$dotest/msgnum"
 571echo $msgnum >"$dotest/end"
 572
 573end=$msgnum
 574msgnum=1
 575
 576while test "$msgnum" -le "$end"
 577do
 578        call_merge "$msgnum"
 579        continue_merge
 580done
 581
 582finish_rb_merge